/*
 *  TOPPERS/SSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 by Meika Sugimoto
 *  Copyright (C) 2013-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * ꥢɥ饤СLPCXPRESSO-LPC812 ѡ
 */

#include <kernel.h>
#include <sil.h>
//#include "kernel_int.h"
#include "target_serial.h"
#include "target_syssvc.h"

/*
 * 쥸
 */
#define INDEX2SIOPID(index) 	((index) + 1)	// ǥåݡID
#define SIOPID2INDEX(siopid)	((siopid) - 1)	// ݡID饤ǥå
#define GET_SIOPCB(siopid)  	(&siopcb_table[SIOPID2INDEX(siopid)])
#define GET_SIOPID(siopcb)  	((siopcb-(uint32_t)siopcb_table)/sizeof(siopcb_table[0]))

/*
 * ꥢI/Oݡȴ֥åꥢ
 */
SIOPCB siopcb_table[TNUM_PORT];

// ꥢɥ饤(GDIC)ΥݡIDб륷ꥢݡ(PDIC)Υ쥸١ɥ쥹
// бطѹ(㤨ХݡID1USART1бŤ)ѹ
static const uint32_t sioreg_table[TNUM_PORT] = {
	TADR_USART_BASE(0),
#if (TNUM_PORT == 2)
	TADR_USART_BASE(1),
#endif
};

Inline bool_t  sio_putready(SIOPCB* siopcb)
{
	uint32_t tmp;
	tmp = sil_rew_mem((void *)TADR_USART_STAT(siopcb->reg));

	return (tmp & TBITPTN_USART_STAT_TXRDY) != 0;
}

Inline bool_t sio_getready(SIOPCB* siopcb)
{
	uint32_t tmp;
	tmp = sil_rew_mem((void *)TADR_USART_STAT(siopcb->reg));

	return (tmp & TBITPTN_USART_STAT_RXRDY) != 0;
}

static bool_t initialized[TNUM_SIOP] = {false};
/*
 *  ٥Ϥν
 */
void target_low_output_init(ID siopid)
{
	uint32_t base = TADR_USART_BASE(SIOPID2INDEX(siopid));
	volatile uint32_t tmp;
	
	if(initialized[siopid]) {return;}

	// UARTϩ˶뤹륯åʥᥤ󥯥åʬ
	sil_wrw_mem((void *)TADR_SYSCON_UARTCLKDIV, TVALUE_SYSCON_UARTCLKDIV);

	/* USART̵ꥻå */
	dis_int(INT_UART0);
	tmp = sil_rew_mem((void *)TADR_USART_CFG(base));
	tmp &= ~TBITPTN_USART_CFG_ENABLE;
	sil_wrw_mem((void *)TADR_USART_CFG(base), tmp);

	// UART0ΥåON
	tmp = sil_rew_mem((void *)TADR_SYSCON_SYSAHBCLKCTRL);
	tmp |= TBITPTN_SYSCON_SYSAHBCLKCTRL_UART0;
	sil_wrw_mem((void *)TADR_SYSCON_SYSAHBCLKCTRL, tmp);

	// ǥХꥻå
	tmp = sil_rew_mem((void *)TADR_SYSCON_PRESETCTRL);
	tmp &= ~TBITPTN_SYSCON_PRESETCTRL_USART0_RST_N;
	sil_wrw_mem((void *)TADR_SYSCON_PRESETCTRL, tmp);
	tmp |= TBITPTN_SYSCON_PRESETCTRL_USART0_RST_N;
	sil_wrw_mem((void *)TADR_SYSCON_PRESETCTRL, tmp);

	/* ̿⡼ */
	tmp = (TBITPTN_USART_CFG_DATALEN_8BIT | TBITPTN_USART_CFG_PARITYSEL_NOPARITY | TBITPTN_USART_CFG_STOPLEN_1BIT);
	sil_wrw_mem((void *)TADR_USART_CFG(base), tmp);

	/* ̿® */
	sil_wrw_mem((void *)TADR_USART_BRG(base), TVALUE_USART_BRG(UART_BAUDRATE));
	sil_wrw_mem((void *)TADR_SYSCON_UARTFRGDIV, TVALUE_SYSCON_UARTFRGDIV);
	sil_wrw_mem((void *)TADR_SYSCON_UARTFRGMULT, TVALUE_SYSCON_UARTFRGMULT(UART_BAUDRATE));

	// CTS/RTSΥꥢ
	sil_wrw_mem((void *)TADR_USART_STAT(base), (TBITPTN_USART_STAT_DELTACTS | TBITPTN_USART_STAT_DELTARXBRK));

	// UARTγߵ
//	ena_int(INT_UART0);

	// UARTθ̤γͭ/̵(̵ͭ)
//	sil_wrw_mem((void *)TADR_USART_INTENSET(base), TBITPTN_USART_INTENSET_RXRDYEN);
//	sil_wrw_mem((void *)TADR_USART_INTENCLR(base), TBITPTN_USART_INTENCLR_TXRDYCLR);

	/* USARTͭ */
	tmp = sil_rew_mem((void *)TADR_USART_CFG(base));
	tmp |= TBITPTN_USART_CFG_ENABLE;
	sil_wrw_mem((void *)TADR_USART_CFG(base), tmp);

	initialized[siopid] = true;
}

/*
 *  åȤΥꥢ
 */
void target_usart_init(ID siopid)
{
	target_low_output_init(siopid);
	
	/* ߵ */
	(void)ena_int(INTNO_SIO);
}

/*
 *  åȤΥꥢ뽪λ
 */
void target_usart_term(uint32_t base)
{
	uint32_t tmp;

	/* ߶ػ */
	(void)dis_int(INTNO_SIO);
	
	/* USART̵ */
	tmp = sil_rew_mem((void *)TADR_USART_CFG(base));
	tmp &= ~TBITPTN_USART_CFG_ENABLE;
	sil_wrw_mem((void *)TADR_USART_CFG(base), tmp);

	int_t siopid = GET_SIOPID(base);
	initialized[siopid] = false;
}

/*
 *  SIO
 */
void sio_initialize(intptr_t exinf)
{
	int i;

	for (i = 0; i < TNUM_PORT; i++) {
		siopcb_table[i].reg = sioreg_table[i];
		siopcb_table[i].exinf = 0;
	}
}

/*
 *  ꥢ륪ץ
 */
SIOPCB *sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB* siopcb;

	if (siopid > TNUM_PORT || siopid < 0) {
		return NULL;
	}
	
	target_usart_init(siopid);

	siopcb = GET_SIOPCB(siopid);
	siopcb->exinf = exinf;

	return siopcb;
}

/*
 *  ꥢ륯
 */
void sio_cls_por(SIOPCB *p_siopcb)
{
	target_usart_term(p_siopcb->reg);
}

/*
 *  ߥϥɥ
 */
void sio_isr(intptr_t exinf)
{
	SIOPCB* siopcb = GET_SIOPCB(exinf);

    if (sio_putready(siopcb)) {
            sio_irdy_snd(siopcb->exinf);
    }
    if (sio_getready(siopcb)) {
            sio_irdy_rcv(siopcb->exinf);
    }
}


/*
 *  1ʸ
 */
bool_t sio_snd_chr(SIOPCB *siopcb, char c)
{
	bool_t ret = false;
	
	if (sio_putready(siopcb)) {
		sil_wrw_mem((void *)TADR_USART_TXDATA(siopcb->reg), c);
		ret = true;
	}

	return ret;
}

/*
 *  1ʸ
 */
int_t sio_rcv_chr(SIOPCB *siopcb)
{
	int_t c = -1;

	if (sio_getready(siopcb)) {
		c = (int_t)sil_rew_mem((void *)TADR_USART_RXDATA(siopcb->reg));
	}

	return c;
}

/*
 *  Хåε
 */
void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		sil_wrw_mem((void *)TADR_USART_INTENSET(siopcb->reg), TBITPTN_USART_INTENSET_TXRDYEN);
		break;
	case SIO_RDY_RCV:
		sil_wrw_mem((void *)TADR_USART_INTENSET(siopcb->reg), TBITPTN_USART_INTENSET_RXRDYEN);
		break;
	default:
		break;
	}
}

/* 
 *  Хåζػ
 */
void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		sil_wrw_mem((void *)TADR_USART_INTENCLR(siopcb->reg), TBITPTN_USART_INTENCLR_TXRDYCLR);
		break;
	case SIO_RDY_RCV:
		sil_wrw_mem((void *)TADR_USART_INTENCLR(siopcb->reg), TBITPTN_USART_INTENCLR_RXRDYCLR);
		break;
	default:
		break;
	}
}

/*
 *  1ʸϡʥݡ󥰤Ǥνϡ
 */
void sio_pol_snd_chr(char c, ID siopid)
{
	uint32_t base = TADR_USART_BASE(SIOPID2INDEX(siopid));
	volatile uint32_t tmp;

	do {
		tmp = sil_rew_mem((void *)TADR_USART_STAT(base));
	} while((tmp & TBITPTN_USART_STAT_TXRDY) == 0);

	sil_wrw_mem((void *)TADR_USART_TXDATA(base), (uint32_t)c);
}
